unit scanpreview;

interface

uses

  Forms, Dialogs, hyieutils, iexBitmaps, hyiedefs, sysutils,
  iesettings, ieview, imageenview, StdCtrls,
  ExtCtrls, iexacquire, Buttons, Controls, Classes;

type
  Tscanpreview_form = class(TForm)
    img: TImageEnView;
    ok_but: TSpeedButton;
    JfSpeedButton1: TSpeedButton;
    w_edit: TEdit;
    h_edit: TEdit;
    JfSpeedButton2: TSpeedButton;
    x_edit: TEdit;
    y_edit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    dpi_edit: TEdit;
    Label5: TLabel;
    procedure ok_butClick(Sender: TObject);
    procedure JfSpeedButton1Click(Sender: TObject);
    procedure w_editChange(Sender: TObject);
    procedure h_editChange(Sender: TObject);
    procedure imgSelectionChanging(Sender: TObject);
    procedure JfSpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
    Fw,Fh:integer;
//    Fl,Ft,Fb,Fr:double;
    Fdpix_preview:double;
    Fdpiy_preview:double;
    procedure aggiorna_selezione;
    procedure load_preview;
  public
    { Public declarations }
  end;

  function attiva_preview_scansione(var l,t,w,h:double):boolean;

var
  scanpreview_form: Tscanpreview_form;

implementation

{$R *.dfm}

function attiva_preview_scansione(var l,t,w,h:double):boolean;
begin
  scanpreview_form:=Tscanpreview_form.Create(nil);
  try
    with scanpreview_form do
    begin
      load_preview;

      result:=(showmodal=mrOk);

      if result then
      begin
        l:=strtofloat(x_edit.text);
        t:=strtofloat(y_edit.text);
        w:=strtofloat(w_edit.text);
        h:=strtofloat(h_edit.text);
      end;
    end;
  finally
    scanpreview_form.Free;
  end;
end;

procedure Tscanpreview_form.h_editChange(Sender: TObject);
begin
  aggiorna_selezione;
end;

procedure Tscanpreview_form.imgSelectionChanging(Sender: TObject);
var
  x,y,w,h:integer;
begin
  x:=img.SelectedRect.x;
  y:=img.SelectedRect.y;
  w:=img.SelectedRect.width;
  h:=img.SelectedRect.height;

  x_edit.text:=floattostr((x/Fdpix_preview)*2.54);
  y_edit.text:=floattostr((y/Fdpiy_preview)*2.54);

  if (not(w=Fw) or not(h=Fh)) then
  begin
    w_edit.text:=floattostr((w/Fdpix_preview)*2.54);
    h_edit.text:=floattostr((h/Fdpiy_preview)*2.54);
  end;

  Fw:=w;
  Fh:=h;
end;

procedure Tscanpreview_form.JfSpeedButton1Click(Sender: TObject);
begin
  modalresult:=mrCancel;
end;

procedure Tscanpreview_form.JfSpeedButton2Click(Sender: TObject);
begin
  Fdpix_preview:=strtoint(dpi_edit.text);
  Fdpiy_preview:=Fdpix_preview;
  load_preview;
end;

procedure Tscanpreview_form.w_editChange(Sender: TObject);
begin
  aggiorna_selezione;
end;

procedure Tscanpreview_form.ok_butClick(Sender: TObject);
begin
  modalresult:=mrOK;
end;

procedure Tscanpreview_form.aggiorna_selezione;
var
  w,h:double;
  x1,y1,x2,y2:integer;
begin
  x1:=img.SelectedRect.x;
  y1:=img.SelectedRect.y;

  try
    w:=strtofloat(w_edit.text);
  except
    w:=0;
  end;

  try
    h:=strtofloat(h_edit.text);
  except
    h:=0;
  end;

  x2:=x1+trunc(w*Fdpix_preview/2.54);
  y2:=y1+trunc(h*Fdpiy_preview/2.54);

  img.SelectionBase := iesbBitmap;
  img.Select(x1,y1,x2,y2);
  Fw:=X2-x1;
  Fh:=y2-y1;
end;

procedure Tscanpreview_form.load_preview;
begin
  Fdpix_preview:=strtoint(dpi_edit.Text);
  Fdpiy_preview:=Fdpix_preview;

  img.io.AcquireParams.xresolution:=Fdpix_preview;
  img.io.AcquireParams.yresolution:=Fdpiy_preview;
  img.io.AcquireParams.VisibleDialog:=false;

  img.IO.Acquire;

  Fdpix_preview:=img.DpiX;
  Fdpiy_preview:=img.DpiY;
end;

end.

